package com.cogitarecomputing.energydefender;

import flash.display.Sprite;
import flash.display.Bitmap;
import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.display.BitmapData;
import com.cogitarecomputing.energydefender.Main.ButtonActions;

/**
 * ...
 * @author 
 */
class Button extends Sprite
{
	var m_normal:Bitmap;
	var m_mouseOver:Bitmap;
	var m_main:Main;
	var m_action:ButtonActions;
	var m_mouseDown:Bool;

	private function mouseUp(event:MouseEvent):Void
	{
		if (m_mouseDown)
		{
			m_main.tickSound.play();
			m_main.performAction(m_action);
		}
		m_mouseDown = false;
	}
	
	private function mouseDown(event:MouseEvent):Void
	{
		m_mouseDown = true;
	}
	
	private function mouseOut(event:MouseEvent):Void
	{
		m_normal.visible = true;
		m_mouseOver.visible = false;
	}
	
	private function mouseOver(event:MouseEvent):Void
	{
		m_normal.visible = false;
		m_mouseOver.visible = true;
	}
	
	public function new(posX:Int, posY:Int, normalBmp:BitmapData, mouseOverBmp:BitmapData, main:Main, actions:ButtonActions) 
	{
		super();
		m_normal = new Bitmap(normalBmp);
		m_normal.visible = true;
		m_mouseOver = new Bitmap(mouseOverBmp);
		m_mouseOver.visible = false;
		m_main = main;
		m_action = actions;
		x = posX;
		y = posY;
		addChild(m_normal);
		addChild(m_mouseOver);
		m_mouseDown = false;
		m_main.addChild(this);
		addEventListener( MouseEvent.MOUSE_UP, mouseUp);
		addEventListener( MouseEvent.MOUSE_DOWN, mouseDown);
		addEventListener( MouseEvent.MOUSE_OVER, mouseOver);
		addEventListener( MouseEvent.MOUSE_OUT, mouseOut);
	}
}