package com.cogitarecomputing.energydefender;
import com.cogitarecomputing.energydefender.Enemy.EnemyTypes;
/**
 * ...
 * @author 
 */
class EnemyHandler extends UpdateableSprite
{
	private var m_enemies:Array<Enemy>;
	public var m_enemiesPerWave:Int;
	public var m_waves:Int;
	private var m_waveSpeed:Float;
	private var m_enemySpeed:Float;
	public var m_totalEnemies:Int;
	private var m_main:Main;
	
	public function AnyVisibleEnemies():Bool
	{
		for (e in m_enemies)
		{
			if (e.visible)
				return true;
		}
		return false;
	}
	
	public function findClosestEnemy(px:Float, py:Float):Enemy
	{
		var closestdist:Float = 100000000;
		
		var closestEnemy:Enemy = null;
		for (e in m_enemies)
		{
			if (e.visible)
			{
				var dx = px - e.x;
				var dy = py - e.y;
				var d = dx * dx + dy * dy;
				if (d < closestdist)
				{
					closestdist = d;
					closestEnemy = e;
				}
			}
		}
		return closestEnemy;
	}

	public function RemoveAllEnemies()
	{
		var totEnemies = m_waves * m_enemiesPerWave;
		for (e in m_enemies)
		{
			e.visible = false;
			removeChild(e);
		}
		m_enemies = new Array<Enemy>();
	}
	
	private var totTime:Float;
	private function GetRndEnemyType():EnemyTypes
	{
		var rnd = Math.random();
		if (rnd < 0.25)
			return EnemyTypes.StraightAttackAndExplodeAtEnergySource;
		if (rnd < 0.5)
			return EnemyTypes.StraightAttackAndExplodeAtTower;
		if (rnd < 0.75)
			return EnemyTypes.FireAtEnergySource;
		
		return EnemyTypes.FireAtTower;		
	}
	
	public override function Update(deltaTime:Float):Void
	{
		if (totTime > m_waveSpeed)
		{
			totTime = 0.0;
		}
		if (totTime < 0.1 && m_totalEnemies > 0)
		{			
			for (c in 0...m_enemiesPerWave)
			{
				var rnd = Math.random() * Math.PI * 2;
				var px = 400 * Math.cos(rnd) + 320;
				var py = 300 * Math.sin(rnd) + 240;
				var nme = new Enemy(px, py, m_enemySpeed, GetRndEnemyType(), m_main);				
				m_enemies.push(nme);
				addChild(nme);
				m_totalEnemies--;
			}
		}

		totTime += deltaTime;

		for (e in m_enemies)
		{
			if (e.visible)
			{
				e.Update(deltaTime);
			}
		}
	}
	
	public function new(enemiesPerWave:Int, waves:Int, waveSpeed:Float, enemySpeed:Float, main:Main) 
	{
		super();
		m_main = main;
		totTime = 0.0;
		m_enemies = new Array<Enemy>();
		m_enemiesPerWave = enemiesPerWave;
		m_waves = waves;
		m_waveSpeed = waveSpeed;
		m_enemySpeed = enemySpeed;
		m_totalEnemies = m_waves * m_enemiesPerWave;
		
	}
	
}