package com.cogitarecomputing.energydefender;

import flash.display.Bitmap;
import flash.display.Sprite;
import flash.display.BitmapData;
import openfl.Assets;

/**
 * ...
 * @author 
 */
class ExplosionHandler extends UpdateableSprite
{
	private var m_explosions:Array<Explosion>;
	private var m_bd:BitmapData;
	private var m_bd2:BitmapData;
	
	public override function Update(deltaTime:Float):Void
	{
		var removable:Array<Explosion> = new Array<Explosion>();
		for (e in m_explosions)
		{
			e.Update(deltaTime);
			if (e.m_timer > Math.PI * 2)
			{
				removable.push(e);
			}
		}
		for (r in removable)
		{
			removeChild(r);
			m_explosions.remove(r);
		}
	}

	public function AddExplosion(px:Float, py:Float, bigger:Bool)
	{
		var ex = new Explosion(bigger ? m_bd2 : m_bd);
		ex.x = px;
		ex.y = py;
		addChild(ex);
		m_explosions.push(ex);
	}
	
	public function new() 
	{
		super();
		m_explosions = new Array<Explosion>();
		m_bd = Assets.getBitmapData("img/explosion.png");
		m_bd2 = Assets.getBitmapData("img/explosion2.png");
	}
	
}