package com.cogitarecomputing.energydefender;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Sprite;
import flash.events.Event;
import flash.geom.Rectangle;
import flash.Lib;
import flash.events.KeyboardEvent;
import flash.ui.Keyboard;
import flash.events.MouseEvent;
import openfl.Assets;
import flash.media.Sound;
import flash.media.SoundChannel;
import flash.text.TextField;
import flash.text.Font;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

/**
 * ...
 * @author 
 */
	enum ButtonActions
	{
		AddRange;
		RemoveRange;
		AddSpeed;
		RemoveSpeed;
		AddPower;
		RemovePower;
		AddArea;
		RemoveArea;
		AddShots;
		RemoveShots;
		DonePlacingTower;
	}

class Main extends Sprite 
{
	var inited:Bool;

	private var m_arena:Bitmap;
	private var m_normalPlusButton:BitmapData;
	private var m_mouseOverPlusButton:BitmapData;
	private var m_normalMinusButton:BitmapData;
	private var m_mouseOverMinusButton:BitmapData;
	public var m_tower:Tower;
	public var m_energySources:Array<EnergySource>;
	public var m_enemyHandler:EnemyHandler;
	private var m_oldTime:Int;
	public var m_shotHandler:ShotHandler;
	private var font:Font = null;
	private var textFormat:TextFormat;
	private var rangeText:TextField;
	private var speedText:TextField;
	//private var areaText:TextField;
	private var powerText:TextField;
	private var shotsText:TextField;
	private var levelText:TextField;
	private var enemiesLeftText:TextField;
	private var scoreText:TextField;
	private var skillPointsText:TextField;
	private var m_level:Int;
	private var m_nextLevel:Bool;
	private var m_nextLevelBmp:Bitmap;
	private var m_enemies:Sprite;
	private var m_shots:Sprite;
	private var enemiesPerWaveTxt:TextField;
	private var wavesTxt:TextField;
	private var startButton:Button;
	public var m_explosionHandler:ExplosionHandler;
	private var m_titleBmp:Bitmap;
	private var isTitle:Bool;
	private var isGameOver:Bool;
	private var m_gameOverBmp:Bitmap;
	private var gameOverTick:Float;
	private var isFadeToTitle:Bool;
	private var m_congratsBmp:Bitmap;
	private var congratsTick:Float;
	private var isComplete:Bool;
	
	public var shipExplodeSnd:Sound;
	public var shotExplodeSnd:Sound;
	public var towerShotSnd:Sound;
	public var enemyShotSnd:Sound;
	public var gameOverSnd:Sound;
	public var congratSnd:Sound;
	public var tickSound:Sound;
	
	private var music1:Sound;
	private var music1Channel:SoundChannel = null;

	function resize(e) 
	{
		if (!inited) init();
		// else (resize or orientation change)
	}
		
	public function performAction(action:ButtonActions):Void
	{
		if (m_nextLevel)
		{
			if (action == ButtonActions.DonePlacingTower)
			{
				m_nextLevel = false;
				m_nextLevelBmp.visible = false;
				wavesTxt.visible = false;
				enemiesPerWaveTxt.visible = false;
				startButton.visible = false;				
			}
			return;
		}
		
		if (action == ButtonActions.AddArea
		|| action == ButtonActions.AddRange
		|| action == ButtonActions.AddSpeed
		|| action == ButtonActions.AddPower
		|| action == ButtonActions.AddShots
		)
		{
			if (m_tower.m_skillPoints > 0)
			{
				m_tower.m_skillPoints--;
			}
			else
			{
				return;
			}
		}

		if (action == ButtonActions.RemoveArea
		|| action == ButtonActions.RemoveRange
		|| action == ButtonActions.RemoveSpeed
		|| action == ButtonActions.RemovePower
		|| action == ButtonActions.RemoveShots
		)
		{
			
		}

		if (action == ButtonActions.AddArea && m_tower.m_area < 9)
			{
				m_tower.m_area += 1.0;
			}
		if (action == ButtonActions.AddRange && m_tower.m_range < 9)
			{
				m_tower.m_range += 1.0;
			}
		if (action == ButtonActions.AddSpeed && m_tower.m_speed < 9)
			{
				m_tower.m_speed += 1.0;
			}
		if (action == ButtonActions.AddPower && m_tower.m_power < 9)
			{
				m_tower.m_power += 1.0;
			}
		if (action == ButtonActions.AddShots && m_tower.m_shield < 9)
			{
				m_tower.m_shield += 1.0;
			}
		
		if (action == ButtonActions.RemoveArea && m_tower.m_area > 1)
			{
				m_tower.m_area -= 1.0;
				m_tower.m_skillPoints++;
			}
		if (action == ButtonActions.RemoveRange && m_tower.m_range > 1)
			{
				m_tower.m_range -= 1.0;
				m_tower.m_skillPoints++;
			}
		if (action == ButtonActions.RemoveSpeed && m_tower.m_speed > 1)
			{
				m_tower.m_speed -= 1.0;
				m_tower.m_skillPoints++;
			}
		if (action == ButtonActions.RemovePower && m_tower.m_power > 1)
			{
				m_tower.m_power -= 1.0;
				m_tower.m_skillPoints++;
			}
		if (action == ButtonActions.RemoveShots && m_tower.m_shield > 1)
			{
				m_tower.m_shield -= 1;
				m_tower.m_skillPoints++;
			}
	}
	private function updateText()
	{				
		speedText.text = "" + Math.round(m_tower.m_speed);
		rangeText.text = "" + Math.round(m_tower.m_range);
		//areaText.text = "" + Math.round(m_tower.m_area);
		powerText.text = "" + Math.round(m_tower.m_power);
		shotsText.text = "" + Math.round(m_tower.m_shield);
		skillPointsText.text = "" + m_tower.m_skillPoints;
		scoreText.text = "" + m_tower.m_score;
		levelText.text = "" + m_level;
		enemiesLeftText.text = "" + m_enemyHandler.m_totalEnemies;
	}
	private function this_onEnterFrame (event:Event):Void
	{
		if (isFadeToTitle)
		{
			m_titleBmp.alpha += 0.1;
			if (m_titleBmp.alpha >= 1.0)
			{
				m_titleBmp.alpha = 1.0;
				isTitle = true;
				isFadeToTitle = false;
			}
			return;
		}
		if (isGameOver)
		{
			gameOverTick += 0.04;
			m_gameOverBmp.x = 160;
			m_gameOverBmp.y = 320 * Math.sin(gameOverTick) - 160;
			m_gameOverBmp.visible = true;
			if (gameOverTick > Math.PI*1.5)
			{
				isGameOver = false;
				isFadeToTitle = true;
				m_titleBmp.alpha = 0.0;
				m_titleBmp.visible = true;
				m_gameOverBmp.visible = false;
			}
			return;
		}
		if (isComplete)
		{
			congratsTick += 0.01;
			m_congratsBmp.x = 160;
			m_congratsBmp.y = 320 * Math.sin(congratsTick) - 120;
			m_congratsBmp.visible = true;
			if (congratsTick > Math.PI*1.5)
			{
				isComplete = false;
				isFadeToTitle = true;
				m_titleBmp.alpha = 0.0;
				m_titleBmp.visible = true;
				m_congratsBmp.visible = false;
			}
			return;
		}
		if (isTitle)
		{
			return;
		}
		if (m_titleBmp.visible && m_titleBmp.alpha > 0.0)
		{
			m_titleBmp.alpha -= 0.1;
			if (m_titleBmp.alpha <= 0.0)
			{
				m_titleBmp.visible = false;
			}
		}
		if (m_nextLevel)
		{
			return;
		}
		var t:Int = Lib.getTimer();
		var deltaTime:Float = t - m_oldTime;
		m_oldTime = t;
		
		m_tower.Update(deltaTime);
		m_enemyHandler.Update(deltaTime);
		for (energysource in m_energySources)
		{
			energysource.Update(deltaTime);
		}
		m_shotHandler.Update(deltaTime);
		m_explosionHandler.Update(deltaTime);
		updateText();
		if (m_enemyHandler.m_totalEnemies <= 0 && !m_enemyHandler.AnyVisibleEnemies())
		{
			triggerNextLevel();
		}
		if (m_tower.energy <= 0.0 || allEnergySourcesGone() && !isGameOver && !isFadeToTitle)
		{
			isGameOver = true;
			gameOverTick = 0.0;
			gameOverSnd.play();
		}
	}
	
	private function allEnergySourcesGone():Bool
	{		
		for (e in m_energySources)
		{
			if (e.energy > 0.0)
			{
				return false;
			}
		}
		return true;
	}
	public function triggerNextLevel():Void
	{
		if (m_level == 9)
		{
			isComplete = true;
			congratsTick = 0.0;
			congratSnd.play();
			return;
		}
		
		reset(m_level + 1);
		
		m_lastX = 320;
		m_lastY = 240;
		m_nextLevelBmp.visible = true;
		enemiesPerWaveTxt.text = ""+m_enemyHandler.m_enemiesPerWave;
		enemiesPerWaveTxt.visible = true;
		wavesTxt.text = "" + m_enemyHandler.m_waves;
		wavesTxt.visible = true;			
		startButton.visible = true;
		m_nextLevel = true;
		
	}
	public function findClosestEnergySource(px:Float, py:Float):EnergySource
	{
		var closestdist:Float = 100000000;
		
		var closestEnergySource:EnergySource = null;
		for (e in m_energySources)
		{
			if (e.visible)
			{
				var dx = px - e.x;
				var dy = py - e.y;
				var d = dx * dx + dy * dy;
				if (d < closestdist)
				{
					closestdist = d;
					closestEnergySource = e;
				}
			}
		}
		return closestEnergySource;
	}
	
	private function setupTextField(txtField:TextField, textColor:Int, px:Float, py:Float, w:Float):Void
	{		
		txtField.x = px;
		txtField.y = py;
		txtField.width = w;
		txtField.text = "0";
		txtField.selectable = false;
		txtField.defaultTextFormat = textFormat;		
		txtField.setTextFormat(textFormat);
		txtField.embedFonts = true;
		txtField.textColor = textColor;
		txtField.visible = true;
		addChild(txtField);
	}
	
	private function getEnemyHandler(level:Int):EnemyHandler
	{
		switch(level)
		{
			case 1:
				return new EnemyHandler(2, 4, 10000.0, 0.2, this);
			case 2:
				return new EnemyHandler(3, 2, 10000.0, 0.5, this);
			case 3:
				return new EnemyHandler(4, 4, 10000.0, 0.5, this);
			case 4:
				return new EnemyHandler(5, 5, 7000.0, 0.3, this);
			case 5:
				return new EnemyHandler(6, 5, 7000.0, 0.5, this);
			case 6:
				return new EnemyHandler(6, 6, 7000.0, 0.5, this);
			case 7:
				return new EnemyHandler(6, 7, 5000.0, 0.5, this);
			case 8:
				return new EnemyHandler(8, 5, 7000.0, 0.8, this);
			case 9:
				return new EnemyHandler(9, 9, 5000.0, 0.5, this);				
		}
		return new EnemyHandler(2, 4, 10000.0, 0.2, this);
	}
	private function addEnergySource(px:Float, py:Float):Void
	{
		var src = new EnergySource(px, py, this);
		m_energySources.push(src);
		m_enemies.addChild(src);
	}
	
	function reset(level:Int):Void
	{
		m_nextLevel = false;
		m_level = level;
		if (m_enemyHandler != null)
		{
			m_enemies.removeChild(m_enemyHandler);
		}
		var lvl:Float = m_level;
		var waveSpeed:Float = 10000.0 - (100 * lvl);
		if (waveSpeed < 3000.0)
			waveSpeed = 3000.0;
		
		m_tower.energy = 1.0;
		if (m_level == 1)
		{
			m_tower.Reset();
		}
		//m_enemyHandler = new EnemyHandler(Math.round(1+(lvl/2.0)), 3+Math.round(1+(lvl/5.0)), waveSpeed, 0.5+0.05*lvl, this);
		m_enemyHandler = getEnemyHandler(m_level);
		m_enemies.addChild(m_enemyHandler);
	
		if (m_energySources != null)
		{
			for (e in m_energySources)
			{
				m_enemies.removeChild(e);
			}
		}
		m_energySources = new Array<EnergySource>();		
		switch(level)
		{
			case 1:
				addEnergySource(200.0, 200.0);
				addEnergySource(400.0, 400.0);
				addEnergySource(200.0, 400.0);
				addEnergySource(400.0, 200.0);
				addEnergySource(300.0, 100.0);
				addEnergySource(50.0, 100.0);
				addEnergySource(50.0, 50.0);
			case 2:
				addEnergySource(100.0, 100.0);
				addEnergySource(300.0, 300.0);
				addEnergySource(200.0, 200.0);
				addEnergySource(400.0, 400.0);
			case 3:
				addEnergySource(100.0, 100.0);
				addEnergySource(100.0, 300.0);
				addEnergySource(100.0, 200.0);
				addEnergySource(100.0, 400.0);
			case 4:
				addEnergySource(100.0, 100.0);
				addEnergySource(200.0, 100.0);
				addEnergySource(300.0, 100.0);
				addEnergySource(400.0, 100.0);
			case 5:
				addEnergySource(100.0, 300.0);
				addEnergySource(500.0, 300.0);
				addEnergySource(300.0, 100.0);
			case 6:
				addEnergySource(100.0, 300.0);
				addEnergySource(500.0, 400.0);
				addEnergySource(200.0, 300.0);
			case 7:
				addEnergySource(280.0, 200.0);
				addEnergySource(360.0, 400.0);
			case 8:
				addEnergySource(460.0, 220.0);
			case 9:
				addEnergySource(160.0, 220.0);
		}
		/*var sources:Int = Math.round(1 + (lvl / 3));
		for (c in 0...sources)
		{
			var rx:Float = 64 + (stage.stageWidth - 128) * Math.random();
			var ry:Float = 64 + (stage.stageHeight - 128) * Math.random();
			var src = new EnergySource(rx, ry, this);
			m_energySources.push(src);
			m_enemies.addChild(src);
		}*/

		if (m_shotHandler != null)
		{
			m_shots.removeChild(m_shotHandler);
			m_shots.removeChild(m_explosionHandler);
		}
		m_shotHandler = new ShotHandler(this);
		m_shots.addChild(m_shotHandler);
		m_explosionHandler = new ExplosionHandler();
		m_shots.addChild(m_explosionHandler);
		isGameOver = false;
		isComplete = false;
	}
	
	function onKey( down, e : KeyboardEvent )
	{		
		/*if (e.keyCode == Keyboard.A)
		{
			if (!down)
			{
				isGameOver = true;
				gameOverTick = 0.0;
				gameOverSnd.play();
			}
			return;
		}
		if (e.keyCode == Keyboard.S)
		{
			if (!down)
			{
				isComplete = true;
				congratsTick = 0.0;
				congratSnd.play();
			}
			return;
		}
		if (!down)
			triggerNextLevel();*/
	}
	private var isMouseDown:Bool;
	private var m_lastX:Float;
	private var m_lastY:Float;
	private function moveTower(px:Float, py:Float):Void
	{
		//if (py > (480 - 64))
		//	return;
		if (tooCloseToEnergy(px, py))
		{
			m_tower.alpha = 0.2;
		}
		else
		{
			m_tower.alpha = 1.0;
			m_lastX = px;
			m_lastY = py;
		}
		
		if (px < 32)
			px = 32;
		if (py < 64)
			py = 64;
		if (px > (640 - 32))
			px = (640 - 32);
		if (py > (480 - 64))
			py = (480 - 64);
		m_tower.x = px;
		m_tower.y = py;
			
	}
	private function tooCloseToEnergy(px:Float, py:Float):Bool
	{
		for (e in m_energySources)
		{
			var dx:Float = e.x - px;
			var dy:Float = e.y -py;
			var d = Math.sqrt(dx * dx + dy * dy);
			if (d < 48)
			{
				return true;
			}
		}
		return false;
	}
	
	private function mouseUp(event:MouseEvent):Void
	{		
		if (isMouseDown)
		{
			isMouseDown = false;
			if (isTitle)
			{
				tickSound.play();
				isTitle = false;
				m_level = 0;
				triggerNextLevel();
			}
			if (m_nextLevel)
			{
				moveTower(m_lastX, m_lastY);
			}
		}
	}
	private function mouseDown(event:MouseEvent):Void
	{
		if (m_nextLevel && event.stageY > 416)
			return;
			
		isMouseDown = true;
	}
	private function mouseMove(event:MouseEvent):Void
	{
		if (isMouseDown && m_nextLevel && !isTitle)
		{
			moveTower(event.stageX, event.stageY);
		}
	}
	function init() 
	{
		if (inited) return;
		inited = true;
		
		isMouseDown = false;
		m_arena = new Bitmap(Assets.getBitmapData("img/arena.jpg"));
		addChild(m_arena);
		m_tower = new Tower(this);
		m_tower.x = stage.stageWidth  / 2;
		m_tower.y = stage.stageHeight / 2;
		addChild(m_tower);
		m_enemies = new Sprite();
		addChild(m_enemies);		
		//m_enemyHandler = new EnemyHandler(3, 5, 10000.0, 0.5, this);
		//addChild(m_enemyHandler);
		m_shots = new Sprite();
		addChild(m_shots);
		//m_shotHandler = new ShotHandler(this);
		//addChild(m_shotHandler);
		reset(1);
		m_mouseOverMinusButton = Assets.getBitmapData("img/buttonminus.png");
		m_normalMinusButton = Assets.getBitmapData("img/buttonnormalminus.png");
		m_mouseOverPlusButton = Assets.getBitmapData("img/buttonplus.png");
		m_normalPlusButton = Assets.getBitmapData("img/buttonnormalplus.png");
		addChild(new Button(0, 444, m_normalPlusButton, m_mouseOverPlusButton, this, ButtonActions.AddRange));
		addChild(new Button(72, 444, m_normalMinusButton, m_mouseOverMinusButton, this, ButtonActions.RemoveRange));

		addChild(new Button(132, 444, m_normalPlusButton, m_mouseOverPlusButton, this, ButtonActions.AddSpeed));
		addChild(new Button(204, 444, m_normalMinusButton, m_mouseOverMinusButton, this, ButtonActions.RemoveSpeed));

		//addChild(new Button(264, 444, m_normalPlusButton, m_mouseOverPlusButton, this, ButtonActions.AddArea));
		//addChild(new Button(336, 444, m_normalMinusButton, m_mouseOverMinusButton, this, ButtonActions.RemoveArea));

		addChild(new Button(397, 444, m_normalPlusButton, m_mouseOverPlusButton, this, ButtonActions.AddPower));
		addChild(new Button(469, 444, m_normalMinusButton, m_mouseOverMinusButton, this, ButtonActions.RemovePower));

		addChild(new Button(537, 444, m_normalPlusButton, m_mouseOverPlusButton, this, ButtonActions.AddShots));
		addChild(new Button(609, 444, m_normalMinusButton, m_mouseOverMinusButton, this, ButtonActions.RemoveShots));
		font = Assets.getFont("fnt/font.ttf");
		textFormat = new TextFormat(font.fontName);
		textFormat.size = 32;
		textFormat.align = TextFormatAlign.CENTER;
		
		var yp:Float = 442;
		rangeText = new TextField();
		
		setupTextField(rangeText, 0xffff00, 02+40, yp, 24);		
		speedText = new TextField();
		setupTextField(speedText, 0xffff00, 135+40, yp, 24);
		//areaText = new TextField();
		//setupTextField(areaText, 0xffff00, 266+40, yp, 24);
		powerText = new TextField();
		setupTextField(powerText, 0xffff00, 400+40, yp, 24);
		shotsText = new TextField();
		setupTextField(shotsText, 0xffff00, 538+40, yp, 24);
		yp = 15;
		levelText = new TextField();
		setupTextField(levelText, 0xffff00, -15+40, yp, 24);
		enemiesLeftText = new TextField();
		setupTextField(enemiesLeftText, 0xffff00, 159+20, yp, 64);
		scoreText = new TextField();
		setupTextField(scoreText, 0xffff00, 341+0, yp, 100);
		skillPointsText = new TextField();
		setupTextField(skillPointsText, 0xffff00, 512+40, yp, 24);

		m_nextLevel = true;
		m_nextLevelBmp = new Bitmap(Assets.getBitmapData("img/nextlevel.png"));
		//m_nextLevelBmp.visible = false;
		addChild(m_nextLevelBmp);
		wavesTxt = new TextField();
		setupTextField(wavesTxt, 0xff00ff00, 183, 71, 100);
		//wavesTxt.visible = false;
		enemiesPerWaveTxt = new TextField();
		setupTextField(enemiesPerWaveTxt, 0xff00ff00, 45, 125, 100);
		//enemiesPerWaveTxt.visible = false;
		var startButtonBmp = Assets.getBitmapData("img/startbutton.png");
		var startButtonFadedBmp = Assets.getBitmapData("img/startbuttonfaded.png");
		startButton = new Button(0, 416, startButtonBmp, startButtonFadedBmp, this, ButtonActions.DonePlacingTower);
		//startButton.visible = false;
		addChild(startButton);
		
		//Setup levels
		//Fix title menu text
		
		m_gameOverBmp = new Bitmap(Assets.getBitmapData("img/gameover.png"));
		m_gameOverBmp.visible = false;
		isGameOver = false;
		addChild(m_gameOverBmp);
		m_congratsBmp = new Bitmap(Assets.getBitmapData("img/congrats.png"));
		m_congratsBmp.visible = false;
		isComplete = false;
		addChild(m_congratsBmp);
		m_titleBmp = new Bitmap(Assets.getBitmapData("img/title.jpg"));
		addChild(m_titleBmp);
		isTitle = true;
		addEventListener (Event.ENTER_FRAME, this_onEnterFrame);
        stage.addEventListener( KeyboardEvent.KEY_DOWN, onKey.bind(true) );
        stage.addEventListener( KeyboardEvent.KEY_UP, onKey.bind(false) );
		stage.addEventListener( MouseEvent.MOUSE_DOWN, mouseDown);
		stage.addEventListener( MouseEvent.MOUSE_MOVE, mouseMove);
		stage.addEventListener( MouseEvent.MOUSE_UP, mouseUp);
		
		shipExplodeSnd = Assets.getSound("snd/ExplosionShips.wav");
		shotExplodeSnd = Assets.getSound("snd/ExplosionShots.wav");
		towerShotSnd = Assets.getSound("snd/shot1.wav");
		enemyShotSnd = Assets.getSound("snd/shot2.wav");
		gameOverSnd = Assets.getSound("snd/gameover.wav");
		congratSnd = Assets.getSound("snd/congrats.wav");		
		tickSound = Assets.getSound("snd/ticksound.wav");
		
		music1 = Assets.getSound("snd/ed2.mp3");
		music1Channel = music1.play();
		music1Channel.addEventListener (Event.SOUND_COMPLETE, onSoundComplete1);

	}

	private function onSoundComplete1(e:Event):Void
	{
		if (music1Channel != null)
		{
			music1Channel.stop();
		}
		music1Channel = music1.play();
		music1Channel.addEventListener (Event.SOUND_COMPLETE, onSoundComplete1);
	}

	/* SETUP */

	public function new() 
	{
		super();	
		addEventListener(Event.ADDED_TO_STAGE, added);
	}

	function added(e) 
	{
		removeEventListener(Event.ADDED_TO_STAGE, added);
		stage.addEventListener(Event.RESIZE, resize);
		#if ios
		haxe.Timer.delay(init, 100); // iOS 6
		#else
		init();
		#end
	}
	
	public static function main() 
	{
		// static entry point
		Lib.current.stage.align = flash.display.StageAlign.TOP_LEFT;
		Lib.current.stage.scaleMode = flash.display.StageScaleMode.NO_SCALE;
		Lib.current.addChild(new Main());
	}
}
