package com.cogitarecomputing.energydefender;
import com.cogitarecomputing.energydefender.Shot.ShotType;
import flash.display.Bitmap;
import flash.display.BitmapData;

/**
 * ...
 * @author 
 */
enum ShotType
{
	AimAtTower;
	AimAtEnergy;
	AimAtEnemy;
}

class Shot extends UpdateableSprite
{
	private var m_dx:Float;
	private var m_dy:Float;
	private var m_bmp:Bitmap;
	private var m_shotType:ShotType;
	private var m_main:Main;
	private var m_shotPower:Float;
	private var m_lifeLeft:Float;
	private var m_energySource:EnergySource;
	
	public override function Update(deltaTime:Float):Void
	{
		
		if (visible)
		{
			if (m_lifeLeft != -100)
			{
				if (m_lifeLeft <= 0.0)
				{
					visible = false;
					return;
				}
				m_lifeLeft -= deltaTime;
			}
						
			x += m_dx;
			y += m_dy;
			
			if (m_shotType == ShotType.AimAtTower)
			{
				var dx:Float = x - (m_main.m_tower.x);
				var dy:Float = y - (m_main.m_tower.y);
				var d:Float = Math.sqrt(dx * dx + dy * dy);
				if (d < 32)
				{
					//trace("BOOMSHOT");
					var shield:Float = m_main.m_tower.m_shield / 3.0;
					m_main.m_tower.energy -= (m_shotPower/shield);
					m_main.m_explosionHandler.AddExplosion(x, y, false);
					m_main.shotExplodeSnd.play();
					visible = false;
				}				
			}
			else if (m_shotType == ShotType.AimAtEnergy)
			{
				if (m_energySource == null || m_energySource.visible == false)
				{
					m_energySource = m_main.findClosestEnergySource(x, y);
				}
				
				if (m_energySource != null)
				{
					var dx:Float = x - (m_energySource.x);
					var dy:Float = y - (m_energySource.y);
					var d:Float = Math.sqrt(dx * dx + dy * dy);
					if (d < 16)
					{
						//trace("BOOMSHOT");
						visible = false;						
						m_main.shotExplodeSnd.play();
						m_energySource.energy -= m_shotPower;
						m_main.m_explosionHandler.AddExplosion(x, y, false);
					}					
				}
			}
			else if (m_shotType == ShotType.AimAtEnemy)
			{				
				var enemy = m_main.m_enemyHandler.findClosestEnemy(x, y);
				if (enemy != null)
				{					
					var dx:Float = x - (enemy.x);
					var dy:Float = y - (enemy.y);
					var d:Float = Math.sqrt(dx * dx + dy * dy);
					if (d < 24)
					{						
						visible = false;
						enemy.energy -= m_shotPower;						
						m_main.shotExplodeSnd.play();
						m_main.m_explosionHandler.AddExplosion(x, y, false);
						//trace("BOOMSHOTENEMY:"+enemy.energy);
					}					
				}
			}
		}
	}

	public function new(power:Float, lifeTime:Float, px:Float, py:Float, dx:Float, dy:Float, shotBd:BitmapData, shotType:ShotType, main:Main) 
	{
		super();
		m_shotType = shotType;
		m_lifeLeft = lifeTime;
		m_shotPower = power;
		m_main = main;
		m_bmp = new Bitmap(shotBd);
		m_bmp.x = -m_bmp.width * 0.5;
		m_bmp.y = -m_bmp.height * 0.5;
		addChild(m_bmp);
		x = px;
		y = py;
		m_dx = dx;
		m_dy = dy;
		if (m_shotType == ShotType.AimAtEnergy)
		{
			m_energySource = m_main.findClosestEnergySource(x, y);
		}
	}
	
}