package com.cogitarecomputing.energydefender;

import flash.display.Bitmap;
import flash.display.Sprite;
import flash.events.MouseEvent;
import openfl.Assets;
import com.cogitarecomputing.energydefender.Shot.ShotType;
/**
 * ...
 * @author 
 */
class Tower extends UpdateableSprite
{
	private var innerBmp:Bitmap;
	private var innerSprite:Sprite;
	private var outerBmp:Bitmap;
	public var energy:Float;
	private var totalRot:Float;
	public var m_range:Float;
	public var m_speed:Float;
	public var m_area:Float;
	public var m_power:Float;
	public var m_shield:Float;
	private var m_totalTime:Float;
	private var m_main:Main;
	public var m_skillPoints:Int;
	public var m_score:Int;
	private var energyBar:Bitmap;
	private var m_towerSprite:Sprite;
	
	//Missing handling for shots and area
	
	public function AddScore(score:Int):Void
	{
		m_score += score;
		if ((m_score % 10) == 0)
		{
			m_skillPoints += 1;
		}
	}
	public override function Update(deltaTime:Float):Void
	{
		m_totalTime += deltaTime;
		if (m_totalTime > (5000 / m_speed))
		{
			var enemy:Enemy = m_main.m_enemyHandler.findClosestEnemy(x, y);
			if ( enemy != null)
			{
				var dx = enemy.x - x;
				var dy = enemy.y - y;
				var d = 5.0 / Math.sqrt(dx * dx + dy * dy);
				dx *= d;
				dy *= d;
				m_main.towerShotSnd.play();
				m_main.m_shotHandler.Shoot(m_power * 0.3, m_range * 0.3, x, y, dx, dy, ShotType.AimAtEnemy);
			}
			m_totalTime = 0.0;
		}
		totalRot += deltaTime/10.0;		
		innerSprite.rotation = 2*totalRot;
		m_towerSprite.rotation = -totalRot;
		energyBar.scaleX = energy;
		energyBar.scaleY = 0.4;
		//energyBar.rotation = totalRot;
		if (energy <= 0.0 && visible)
		{
			visible = false;			
			m_main.m_explosionHandler.AddExplosion(x, y, true);
		}
		
	}
	
	public function Reset()
	{
		m_area = 1.0;
		m_power = 1.1;
		m_range = 1.0;
		m_shield = 1.0;
		m_speed = 1.0;
		m_skillPoints = 5;
		m_score = 0;
		energy = 1.0;
	}
	
	public function new(main:Main) 
	{
		super();
		m_towerSprite = new Sprite();
		addChild(m_towerSprite);
		Reset();
		innerSprite = new Sprite();
		m_main = main;
		totalRot = 0;
		m_totalTime = 0.0;
		innerBmp = new Bitmap(Assets.getBitmapData("img/outertower.png"));
		innerBmp.x = -innerBmp.width / 2;
		innerBmp.y = -innerBmp.height / 2;
		outerBmp = new Bitmap(Assets.getBitmapData("img/outer2tower.png"));
		outerBmp.x = -outerBmp.width / 2;
		outerBmp.y = -outerBmp.height / 2;
		m_towerSprite.addChild(outerBmp);		
		innerSprite.addChild(innerBmp);
		m_towerSprite.addChild(innerSprite);
		energyBar = new Bitmap(Assets.getBitmapData("img/energybar.png"));
		energyBar.x += 10;
		energyBar.y -= 16;
		energyBar.scaleY = 0.4;
		addChild(energyBar);
	}
	
}